#version 130

uniform mat4 finalMatrix;
uniform vec2 pos;
uniform mat4 projMat;
uniform mat4 mvMat;

in vec3 inVertex;
in vec3 inNormal;
in vec2 inTexCoord;
out vec4 color;
out vec2 texCoord;

void main(void) 
{
	vec3 vertexPos = vec3(pos.x+inVertex.x, pos.y+inVertex.y, inVertex.z);
	float distance = length(vertexPos.xy);
	
	const float maxDist = 15;
	
	vec3 newInNormal = inNormal;
	
	if(distance > maxDist)
	{
		//inVertex.z -= 10;
		newInNormal /= 2;
		
		
		vec3 rotAxis = normalize(cross(vec3(vertexPos.x, vertexPos.y, 0), vec3(vertexPos.x, vertexPos.y, -1)));
		vec3 rotPoint = vec3(vertexPos.xy, vertexPos.z - 5);
		float angle = distance-maxDist > 3.15 ? 3.15 : distance-maxDist;//1.57;
		float c = cos(angle);
		float s = sin(angle);
		/*mat4 rotMatrix = mat4(	c+(rotAxis.x*rotAxis.x*(1-c)), 			rotAxis.x*rotAxis.y*(1-c)-rotAxis.z*s, 	rotAxis.x*rotAxis.z*(1-c)+rotAxis.y*s, 	pos.x, 
								rotAxis.y*rotAxis.x*(1-c)+rotAxis.z*s, 	c+(rotAxis.y*rotAxis.y*(1-c)), 			rotAxis.y*rotAxis.z*(1-c)-rotAxis.x*s, 	pos.y, 
								rotAxis.z*rotAxis.x*(1-c)-rotAxis.y*s, 	rotAxis.z*rotAxis.y*(1-c)+rotAxis.x*s, 	c+(rotAxis.z*rotAxis.z*(1-c)), 			inVertex.z, 
								0, 0, 0, 1);*/
								
		mat4 rotMatrix = mat4(	c+(rotAxis.x*rotAxis.x*(1-c)), 			rotAxis.y*rotAxis.x*(1-c)+rotAxis.z*s, 	rotAxis.z*rotAxis.x*(1-c)-rotAxis.y*s, 	0, 
								rotAxis.x*rotAxis.y*(1-c)-rotAxis.z*s, 	c+(rotAxis.y*rotAxis.y*(1-c)), 			rotAxis.z*rotAxis.y*(1-c)+rotAxis.x*s, 	0, 
								rotAxis.x*rotAxis.z*(1-c)+rotAxis.y*s, 	rotAxis.y*rotAxis.z*(1-c)-rotAxis.x*s, 	c+(rotAxis.z*rotAxis.z*(1-c)), 			0, 
								0, 0, 0, 1);
								
								
								
		vec2 newPos = normalize(pos)*maxDist;
		mat4 trMatrix = mat4(	1, 0, 0, 	0, 
								0, 1, 0, 	0, 
								0, 0, 1,	0, 
								-pos.x+(newPos.x), -pos.y+(newPos.y), inVertex.z-4, 1);
		mat4 mvMatWithTr = mvMat * trMatrix;
		mat4 newMvMat = mvMatWithTr * rotMatrix;
		
		mat4 fm = projMat * newMvMat;
		gl_Position = fm * vec4(inVertex, 1.0);
	}
	else
	{
		mat4 fm = projMat * mvMat;
		gl_Position = fm * vec4(inVertex, 1.0);
	}
	
	//newInNormal.xy = pos;
	color = vec4(newInNormal, 1.0);
	texCoord = inTexCoord;
}
